'                                                                  
' Copyright  2011 Lidor Systems.
' All Rights Reserved.
'
' This SOFTWARE is provided "AS IS", WITHOUT WARRANTY OF ANY KIND.
' either express or implied.                        
'

Public Class Form1
    Private assemblyFullPath As String = Application.ExecutablePath

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        InitList()
    End Sub

    Private Sub InitList()
        Me.listBox1.ItemSpacing = 2
        Me.listBox1.ScrollBarUseTheme = True

        Me.listBox1.SuspendUpdate()

        Me.listBox1.NormalItemStyle.BorderColor = Color.LightGray

        Dim obj As Product = Nothing
        Dim item As LidorSystems.IntegralUI.Lists.ListBoxItem = Nothing

        For i As Integer = 0 To 9
            item = New LidorSystems.IntegralUI.Lists.ListBoxItem()

            obj = CreateProduct(i)
            item.Content = ApplyTemplate(obj)
            item.Tag = obj

            Dim ctrlRate As New ProgressBar()
            ctrlRate.Size = New Size(70, 12)
            ctrlRate.Minimum = 0
            ctrlRate.Maximum = 5
            ctrlRate.Value = obj.Rating
            item.Controls.Add(ctrlRate)

            Me.listBox1.Items.Add(item)
        Next

        Me.listBox1.ResumeUpdate()
    End Sub

    Private Function CreateProduct(ByVal index As Integer) As Product
        Dim obj As New Product(index)

        Select Case index Mod 3
            Case 1
                obj.Name = "Thringer Rostbratwurst"
                obj.Category = "Meat"
                obj.Rating = 2
                obj.Price = 123.79F
                obj.ImageSource = "meat.jpg"
                Exit Select

            Case 2
                obj.Name = "Scottish Longbreads"
                obj.Category = "Confections"
                obj.Rating = 4
                obj.Price = 12.5F
                obj.ImageSource = "confections.jpg"
                Exit Select
            Case Else

                obj.Name = "Ipoh Coffee"
                obj.Category = "Beverages"
                obj.Rating = 3
                obj.Price = 46.0F
                obj.ImageSource = "beverages.jpg"
                Exit Select
        End Select

        Return obj
    End Function

    Private Function ApplyTemplate(ByVal obj As Product) As String
        Dim content As String = String.Empty

        content = "<div>"
        content += "<table cellpadding=""2"" width=""100%"">"
        content += "<tr>"
        content += "<td rowspan=""2""><img assemblypath=""" & assemblyFullPath & """ resource=""" & obj.ImageSource & """></img></td>"
        content += "<td width=""100%""><font size=""10"">" & obj.Name & "</font></td>"
        content += "<td style=""align:middleright;textcolor:DarkBlue"">" & obj.Category & "</td>"
        content += "<td style=""align:middlecenter;hovertextcolor:DarkRed"" width=""50""><a href=""" & obj.Name & """>more ...</a></td>"
        content += "</tr>"
        content += "<tr>"
        content += "<td><control index=""0""></control></td>"
        content += "<td style=""align:middleright""><b>" & obj.Price.ToString("0.00") & "</b></td>"
        content += "</tr>"
        content += "</table>"
        content += "</div>"

        Return content
    End Function

    Private Sub listBox1_ItemObjectClicked(ByVal sender As Object, ByVal e As LidorSystems.IntegralUI.ObjectClickEventArgs) Handles listBox1.ItemObjectClicked
        If TypeOf e.[Object] Is LinkLabel Then
            Dim lLabel As LinkLabel = DirectCast(e.[Object], LinkLabel)
            Dim linkData As [String] = lLabel.Links(0).LinkData.ToString()

            MessageBox.Show("More info for: " & linkData & " clicked")
        End If
    End Sub
End Class
